process.on("uncaughtException", function (err) { });

const path = require("path");
const fs = require("fs");

if (fs.existsSync(path.join(process.cwd(), "/npm"))) {
  var rootModules = path.join(process.cwd(), "/npm/node_modules/");
} else {
  var rootModules = "";
}

let mediainfo

async function exitProcess() {
  await new Promise((resolve) => {

    try {
      mediainfo.close()
    } catch (err) { }

    setTimeout(function () {
      resolve();
    }, 1000);
  });

  process.exit();
}

process.on("message", (infoArray) => {
  if (infoArray[0] === "exitApproved") {
    exitProcess();
  }
});

prep();

async function prep() {

  let filePath = process.argv[2];

  const MediaInfo = require(rootModules + 'mediainfo.js');

  mediainfo = await MediaInfo({ format: 'JSON' })

  let result = await runMediaInfo(filePath, mediainfo)
  let message = [
    "result",
    result
  ];
  process.send(message);
}

async function runMediaInfo(filePath, mediainfo) {
  return new Promise((resolve) => {
    (async function () {
      try {
        fd = fs.openSync(filePath, 'r')
        let getSize = function () { return fs.statSync(filePath).size }

        const readChunk = (size, offset) => {
          const buffer = new Uint8Array(size)
          let result = fs.readSync(fd, buffer, 0, size, offset)
          return buffer
        }
        let result = await mediainfo.analyzeData(getSize, readChunk)
        result = JSON.parse(result).media
        resolve({
          result: "success",
          data: result,
        });

      } catch (err) {
        console.log(err.stack);
        resolve({
          result: "err",
          data: "MediaInfo encountered an err:" + err,
        });
      }
    })();
  });
};
